

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.geom.AffineTransform;
import java.awt.image.RenderedImage;
import javax.swing.JPanel;
import java.awt.geom.*;
import java.awt.image.*;
import java.awt.Image;
import java.awt.TexturePaint;
import java.awt.Polygon;
import java.util.Hashtable;
import java.awt.image.BufferedImage;
import java.awt.event.*;
import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.image.renderable.ParameterBlock;
import java.awt.event.KeyEvent;
import javax.swing.JTree;
import javax.swing.tree.*;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreeSelectionModel;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;


public class DisplayJAI extends JPanel implements MouseListener,MouseMotionListener,MouseWheelListener{
    /** image to display */
    protected BufferedImage source = null;
   
    int sourcecx,sourcecy;
    int sourcew,sourceh;
    int tvecx=0;
    int tvecy=0;
    int [][] sR=null;
    int [][] sG=null;
    int [][] sB=null;
    protected BufferedImage target = null;
    /** image origin relative to panel origin */
    protected int originX = 0;
    protected int originY = 0;
    boolean secvis=false;
    int secx=0;
    int secy=0;
    Color seccolor1 = Color.red;
    Color seccolor2 = Color.blue;
    boolean mouse=false;
    double scale=1.0;
    double pscale=1.0;
    private final Cursor defCursor = Cursor.getPredefinedCursor(Cursor.DEFAULT_CURSOR);
    private final Cursor hndCursor = Cursor.getPredefinedCursor(Cursor.HAND_CURSOR);
    private final Point pp = new Point();
    Color TraColor = new Color(0.0f,0.0f,0.0f,0.0f);
    //Interpolation interp = Interpolation.getInstance(Interpolation.INTERP_BICUBIC_2);
    float alpha=1.0f;
    
    boolean particles=true;
    boolean mousein=false;
    Point mouseLocation = new Point(0,0);
    JScrollPane preScroll=null;
    
    Point mouseMovedpp = new Point(0,0);
    
    Particles 	myp = new Particles();
    
    Particle picked=null;
    //Point mouseLocation = new Point(0,0);

    int mouseState=1;
    /* 
       0: move/zoom image
       1: add particle
       2: remove particle
       3: move/pick particle
       
    */
    
    int tid;
    double px,py,pz;
    
    float cAlpha=0.8f;
    Color ccolor= new Color(0.0f,0.0f,1.0f,cAlpha);
    Color cfillcolor= new Color(1.0f,0.0f,1.0f,0.5f*cAlpha);

    Color Mccolor= new Color(0.0f,0.0f,1.0f,0.5f*cAlpha);
    Color Mcfillcolor= new Color(1.0f,0.0f,1.0f,0.5f*0.5f*cAlpha);

    double classR=1.0;
    double cRadius=5.0;
    ParticleClass selectedClass;//=myp.addClass(ccolor,cfillcolor,0,0);
    
    
    RenderedImage rop =null;
    BufferedImage dbuffer=null;
    BufferedImage dbuffer2=null;
    
    
    
   
    public void setTransparent(float dalpha){
	alpha = dalpha;
	if(alpha>1.0f)alpha=1.0f;if(alpha<0.0f)alpha=0.0f;
	//System.out.println(+alpha);
	makeImage();repaint();
    
    }
    public void setJScrollPane(JScrollPane dpreScroll){
	preScroll = dpreScroll;
	    
    }
    
    public void setCColor(Color inc,Color inMc){
	ccolor = inc;
	Mccolor = inMc;
	makeImage();repaint();
    }
    public void setCFillColor(Color inc,Color inMc){
	cfillcolor = inc;
	Mcfillcolor = inMc;
	makeImage();repaint();
    }

    public void setImage(BufferedImage image){
	source = image;
	repaint();
    }

    /** constructor with given image */
    public DisplayJAI(BufferedImage image) {
        super();
        setLayout(null);
        source = image;
	target = null;
        // Swing geometry
        int w = source.getWidth();sourcew=w;
        int h = source.getHeight();sourceh=h;
	sourcecx=w/2;
	sourcecy=h/2;
        Insets insets = getInsets();
        Dimension dim = new Dimension(w + insets.left + insets.right,
                                      h + insets.top + insets.bottom);
	tid=0;
	px=1.0;
	py=1.0;
	pz=1.0; 
	mouseState=1;
        setPreferredSize(dim);
	addMouseWheelListener(this);
	selectedClass=myp.addClass(ccolor,cfillcolor,0,1);
    

	addMouseMotionListener(this);
        addMouseListener(this);
	makeImage();
    }
    public void setTargetImage(BufferedImage timage){
	target = timage;
	int w = source.getWidth();
        int h = source.getHeight();
	int w2 = target.getWidth();
	int h2 = target.getHeight();
	if(w>w2)w=w2;
	if(h>h2)h=h2;
        Insets insets = getInsets();
        Dimension dim = new Dimension(w + insets.left + insets.right,
                                      h + insets.top + insets.bottom);
	setPreferredSize(dim);
	
	makeImage();
	repaint();
    }

   

    /** move image within it's container */
    public void setOrigin(int x, int y) {
        originX = x;
        originY = y;
        makeImage();repaint();
    }
    
    /** get the image origin */
    public Point getOrigin() {
        return new Point(originX, originY);
    }
    
    /** use to display a new image */
    public void set(BufferedImage im) {
        source = im;
	scale=1.0d;
	pscale=1.0d;
        setSize();
        revalidate();
        makeImage();repaint();
    }
    
    /** use to display a new image, with origins */
    public void set(BufferedImage im, int x, int y) {
        source = im;
		scale=1.0d;
		pscale=1.0d;
        setSize();

        originX = x;
        originY = y;

        revalidate();
        makeImage();repaint();
    }
    
    public synchronized BufferedImage getImage(){
	
	
	ParameterBlock pb = new ParameterBlock();
	pb.add(((float)(scale))); // x scale factor
	pb.add(((float)(scale))); // y scale factor
	pb.add(0.0f); // x translate
	pb.add(0.0f); // y translate
	//pb.add(interp); // interpolation method
	pb.addSource(source);
	//rop = JAI.create("scale", pb,null);
	RenderedImage rop = pb.getRenderedSource(0);
	BufferedImage tmpbuffer = new BufferedImage(rop.getWidth(),rop.getHeight(),BufferedImage.TYPE_INT_RGB);
	Graphics2D g2d = (Graphics2D)tmpbuffer.getGraphics();
	g2d.drawRenderedImage(rop,AffineTransform.getTranslateInstance(0,0));
	
	
        // account for borders
        Insets insets = getInsets();
        int tx = insets.left + originX;
        int ty = insets.top  + originY;
	
	
        // clear damaged component area
        
        g2d.setColor(getBackground());
        g2d.fillRect(0,0,rop.getWidth(),rop.getHeight());
	
	g2d.drawRenderedImage(dbuffer,AffineTransform.getTranslateInstance(0,0));
	
	
	if(myp!=null){
	if(mousein&&(mouseState==1||mouseState==3)){
	    int dr = ((int)(((double)(scale*classR*cRadius))));if(dr-scale*classR*cRadius>=0.5)dr++;
	    int dr2=2*dr;
	    
	    int dx = mouseLocation.x;
	    int dy = mouseLocation.y;
	    g2d.setColor(Mccolor);
	    g2d.drawOval(dx-dr,dy-dr,dr2,dr2);
	    g2d.setColor(Mcfillcolor);
	    g2d.fillOval(dx-dr,dy-dr,dr2,dr2);
	    
	    
	}
	}
	if(secvis){
	    g2d.scale(scale,scale);
	    g2d.setColor(seccolor1);
	    
	    g2d.drawLine(0,secx,getWidth(),secx);
	    g2d.setColor(seccolor2);
	    g2d.drawLine(secy,0,secy,getHeight());
	
	}
	
	
	
	if(myp!=null){
	    if(particles){
		g2d.scale(scale,scale);
		myp.draw(g2d,tid);
		
	    }
	}
	
	
	g2d.dispose();
	return tmpbuffer;
	
    
	}
    /** paint routine */
    public synchronized void paintComponent(Graphics g){

        Graphics2D g2d = (Graphics2D)g;
	
        if(source == null){
            g2d.setColor(getBackground());
            g2d.fillRect(0, 0, getWidth(), getHeight());
            return;
        }
	
        // account for borders
        Insets insets = getInsets();
        int tx = insets.left + originX;
        int ty = insets.top  + originY;
	
	
        // clear damaged component area
        Rectangle clipBounds = g2d.getClipBounds();
        g2d.setColor(getBackground());
        g2d.fillRect(clipBounds.x,
                     clipBounds.y,
                     clipBounds.width,
                     clipBounds.height);
	
	if(dbuffer2!=null)
	    g2d.drawRenderedImage(dbuffer2,AffineTransform.getTranslateInstance(0,0));
	
	g2d.drawRenderedImage(dbuffer,AffineTransform.getTranslateInstance(((double)(tvecx)),((double)(tvecy))));//AffineTransform.getTranslateInstance(0,0));
	
	if(myp!=null){
	    if(mousein&&(mouseState==1||mouseState==3)){
		int dr = ((int)(((double)(scale*classR*cRadius))));
		if(dr-scale*classR*cRadius>=0.5)dr++;
		int dr2=2*dr;
		
		int dx = mouseLocation.x;
		int dy = mouseLocation.y;
		g2d.setColor(Mccolor);
		g2d.drawOval(dx-dr,dy-dr,dr2,dr2);
		g2d.setColor(Mcfillcolor);
		g2d.fillOval(dx-dr,dy-dr,dr2,dr2);
		
		
	    }
	}
	if(secvis){
	    g2d.scale(scale,scale);
	    g2d.setColor(seccolor1);
	    
	    g2d.drawLine(0,secx,getWidth(),secx);
	    g2d.setColor(seccolor2);
	    g2d.drawLine(secy,0,secy,getHeight());
	    
	}
	
	
    }
    
    
   
    
    public void makeImage(){
	/* ParameterBlock pb = new ParameterBlock();
	pb.add(((float)(scale))); // x scale factor
	pb.add(((float)(scale))); // y scale factor
	pb.add(0.0f); // x translate
	pb.add(0.0f); // y translate
	
	pb.addSource(source);
	*/
	//rop = JAI.create("scale", pb,null);
	//RenderedImage rop = pb.getRenderedSource(0);
	dbuffer = new BufferedImage(((int)(((double)((scale*source.getWidth()))))),((int)(((double)((scale*source.getHeight()))))),BufferedImage.TYPE_INT_ARGB);
	AffineTransform at =
	    AffineTransform.getScaleInstance(scale,scale);
	
        Graphics2D g2d = (Graphics2D)dbuffer.getGraphics();
	g2d.setComposite(AlphaComposite.getInstance(AlphaComposite.SRC_OVER,alpha));

	if(target!=null){
	    dbuffer2 = new BufferedImage(target.getWidth(),target.getHeight(),BufferedImage.TYPE_INT_ARGB);
	    Graphics2D g2dt = (Graphics2D)dbuffer2.getGraphics();
	    
	    g2dt.drawRenderedImage(target,null);//AffineTransform.getTranslateInstance(((double)(tvecx)),((double)(tvecy))));
	    
	}
	g2d.drawRenderedImage(source,at);
	
	
	
	if(myp!=null){
	    if(particles){
		g2d.scale(scale,scale);
		myp.draw(g2d,tid);
		
	    }
	}
	g2d.dispose();
	
    }
    
    
   


    
    
    public void initScale() {
            scale = 1.0d;
	    pscale= 1.0d;
            makeImage();
	    repaint();
	    
	    
	    setSize();
        }
    private void setSize(){
	double w = scale*source.getWidth();
	double h = scale*source.getHeight();
	int iw = ((int)(w));if(w-iw>=0.5)iw++;
	int ih = ((int)(h));if(h-ih>=0.5)ih++;
	
	
	Insets insets = getInsets();
	Dimension dim = new Dimension(iw + insets.left + insets.right,
				      ih + insets.top + insets.bottom);
	
	
	setPreferredSize(dim);
	getParent().doLayout(); 
    }
    private void setSize(Point mp){
	double w = scale*source.getWidth();
	double h = scale*source.getHeight();
	int iw = ((int)(w));if(w-iw>=0.5)iw++;
	int ih = ((int)(h));if(h-ih>=0.5)ih++;
	
	
	Insets insets = getInsets();
	Dimension dim = new Dimension(iw + insets.left + insets.right,
				      ih + insets.top + insets.bottom);
	
	getParent().
	setPreferredSize(dim);
	getParent().doLayout(); 
    }
    public void changeScale(int iv,Point cp){
	
	
	scale = Math.max(0.05d, Math.min(10.0d, scale-iv*0.05d));
	double nscale=scale/pscale;
	
	setSize();
	
	
	JViewport vport = preScroll.getViewport();
	Point vp = vport.getViewPosition();
	double dtx = nscale*((double)(cp.x));
	double dty = nscale*((double)(cp.y));
	
	
	int tx = ((int)(dtx));
	if(dtx-tx>=0.5){
	    tx++;
	}else if(dtx-tx<=-0.5){
	    tx--;
	}
	int ty = ((int)(dty));
	if(dty-ty>=0.5){
	    ty++;
	}else if(dty-ty<=-0.5){
	    ty--;
	}
	vp.translate(-mouseMovedpp.x+tx,-mouseMovedpp.y+ty);
	this.scrollRectToVisible(new Rectangle(vp,vport.getSize()));//new Dimension(tx,ty)));//vport.getSize()));
	mouseMovedpp.setLocation(tx,ty);
	pscale=scale;

	makeImage();
	//repaint();
    }
    public void mouseDragged(MouseEvent e) {mousein=true;
	if(mouseState==0){
	    /*
	    Point cp = e.getPoint();
	    JViewport vport = preScroll.getViewport();
	    Point vp = vport.getViewPosition();
	    
	    
	    vp.translate(pp.x-cp.x, pp.y-cp.y);
	    
	    this.scrollRectToVisible(new Rectangle(vp,vport.getSize()));//new Dimension(tx,ty)));//vport.getSize()));
	    */
	    tvecx = e.getPoint().x;
	    tvecy = e.getPoint().y;
	    
	
	    makeImage();
	    repaint();
	}else if(mouseState!=3){
	    if(picked!=null){
		Point cp = e.getPoint();
		double dx = ((double)(cp.x-tvecx))/scale;
		double dy = ((double)(cp.y-tvecy))/scale;
		picked.x = dx;
		picked.y = dy;
		makeImage();
		repaint();
	    }else{
		Point cp = e.getPoint();
		JViewport vport = preScroll.getViewport();
		Point vp = vport.getViewPosition();
		
		
		vp.translate(pp.x-cp.x-tvecx, pp.y-cp.y-tvecy);
		
		this.scrollRectToVisible(new Rectangle(vp,vport.getSize()));//new Dimension(tx,ty)));//vport.getSize()));
		
		
		makeImage();
		repaint();
		
	    
	    }
	}
    } 
    public void mouseMoved(MouseEvent e){mousein=true;
	//keyaction4.mousepoint = e.getPoint();
	if(mouseState==0||mouseState==2){
	    //for zoom
	    mouseMovedpp.setLocation(e.getPoint());
	    pscale=scale;
	    //end zoom
	    
	}else{
	    mouseLocation.setLocation(e.getPoint());
	    if(mouseState==1||mouseState==3){
		
		//repaint();
		repaint();
	    }
	}
    }
    
    public void setMode(int val){
	mouseState=val;
	/*
	if(mouseState==0||mouseState==2){
	    keyaction.mouseWheelState=3;
	}else{
	    if(keyaction.mouseWheelState==3){
		keyaction.mouseWheelStateIncrease();
	    }
	}
	mypcontrol.setMouseWheelState(keyaction.mouseWheelState);
	*/
	repaint();
    }
    private void saveMask(String filename){
	try{
	    
	    FileOutputStream output = 
		new FileOutputStream(filename);
	    PrintWriter pwp = new PrintWriter(output);
	    pwp.println("P2");
	    int tsy = target.getHeight();
	    int tsx = target.getWidth();
	    pwp.println(tsx+" "+tsy);
	    pwp.println(255);
	    
	    
	    Polygon mypoly = new Polygon();
	    myp.setPolygon(mypoly,scale);
	    
	    int i,j;
	    
	    
	    for(i=0;i<tsy;i++){
		int dy = i-tvecy;
		for(j=0;j<tsx;j++){
		    int dx = j-tvecx;
		    if(mypoly.contains(dx,dy)){
			pwp.print(255+" ");
		    }else{
			pwp.print(0+" ");
		    }
		}
		pwp.println("");
	    }
	    
	    pwp.close();
	    output.close();
	}catch (IOException e){
	    System.out.println("IOException");
	    
	}
    }

    private void saveMaskImage(String filename){
	try{
	    Polygon mypoly = new Polygon();
	    myp.setPolygon(mypoly,scale);
	    int tsy = target.getHeight();
	    int tsx = target.getWidth();
	    int i,j;
	    boolean [][] mask = new boolean[tsy][tsx];
	    boolean [][] mask2 = new boolean[tsy][tsx];
	    
	    for(i=0;i<tsy;i++){
		int dy = i-tvecy;
		for(j=0;j<tsx;j++){
		    int dx = j-tvecx;
		    if(mypoly.contains(dx,dy)){
			mask2[i][j]=mask[i][j]=true;
		    }else{
			mask2[i][j]=mask[i][j]=false;
		    }
		}
	    }
	    
	    for(i=1;i<tsy-1;i++){
		
		for(j=1;j<tsx-1;j++){
		    if(!mask[i][j]){
			boolean checkb=false;
			
			for(int ii=-1;ii<=1;ii++){
			    int i2 = i+ii;
			    
			    for(int jj=-1;jj<=1;jj++){
				int j2=j+jj;
				
				if(mask[i2][j2]){
				    checkb=true;
				    break;
				}
			    }
			    if(checkb)break;
			}
		    
		    if(checkb)
		    mask2[i][j]=true;
		    }
		}
	    }
	    



	    FileOutputStream output = 
		new FileOutputStream(filename);
	    PrintWriter pwp = new PrintWriter(output);
	    pwp.println("P3");
	   
	    pwp.println(tsx+" "+tsy);
	    pwp.println(255);
	    
	    
	    
	    
	    
	    int [] RGB = new int[3];
	    int ssx = source.getWidth();
	    int ssy = source.getHeight();
	    for(i=0;i<tsy;i++){
		double dy = ((double)(i-tvecy))/scale;
		for(j=0;j<tsx;j++){
		    double dx = ((double)(j-tvecx))/scale;
		    if(mask2[i][j]){
			
			setRGB(RGB,dx,dy,ssx,ssy);
			pwp.print(RGB[0]+" "+RGB[1]+" "+RGB[2]+" ");
		    }else{
			
			pwp.print(255+" "+255+" "+255+" ");
		    }
		}
		pwp.println("");
	    }
	    
	    pwp.close();
	    output.close();
	}catch (IOException e){
	    System.out.println("IOException");
	    
	}
    }
    //4x4 Cubic
    private double CK81(double ddx){// Cubic Function
	if(0.0<=ddx&&ddx<1.0){
	    return (ddx*ddx*(1.5*ddx-2.5)+1.0);
	}else if(1.0<=ddx&&ddx<2){
	    return (ddx*(ddx*(-0.5*ddx+2.5)-4.0)+2.0);
	}else{
	    return 0.0;
	    
	}
    }

    private void setRGB(int [] RGB,double dx,double dy,int tsx,int tsy){
	int idx = ((int)(dx));
	int idy = ((int)(dy));
	int i,j;
	double sumR=0.0;
	double sumG=0.0;
	double sumB=0.0;
	
	double wsum=0.0;
	
	//System.out.println(dx+" "+dy);
	
	for(i=idy-1;i<=idy+2;i++){
	    int i2=i;if(i2<0)i2=0;if(i2>tsy-1)i2=tsy-1;
	    double wy = CK81(Math.abs(dy-((double)(i))));
	    
	    for(j=idx-1;j<=idx+2;j++){
		int j2=j;if(j2<0)j2=0;if(j2>tsx-1)j2=tsx-1;
		double weight =  wy*CK81(Math.abs(dx-((double)(j))));
		sumR += weight*((double)(sR[i2][j2]));
		sumG += weight*((double)(sG[i2][j2]));
		sumB += weight*((double)(sB[i2][j2]));
		wsum += weight;
	    }
	    
	}
	if(wsum<=0.0)wsum=1.0;
	sumR /= wsum;
	sumG /= wsum;
	sumB /= wsum;
	RGB[0] = ((int)(sumR));if(Math.abs(RGB[0]-sumR)>=0.5)RGB[0]++;if(RGB[0]<0)RGB[0]=0;if(RGB[0]>255)RGB[0]=255;
	RGB[1] = ((int)(sumG));if(Math.abs(RGB[1]-sumG)>=0.5)RGB[1]++;if(RGB[1]<0)RGB[1]=0;if(RGB[1]>255)RGB[1]=255;
	RGB[2] = ((int)(sumB));if(Math.abs(RGB[2]-sumB)>=0.5)RGB[2]++;if(RGB[2]<0)RGB[2]=0;if(RGB[2]>255)RGB[2]=255;
	
    
    
    } 
    public void setSaveMasks(String filename){
	String maskname = filename+".pgm";
	String maskedimage  = filename+".ppm";
	
	saveMask(maskname);
	saveMaskImage(maskedimage);
	
	

    }
    public void mousePressed(MouseEvent e) {mousein=true;
	if(e.getModifiers() == e.BUTTON3_MASK){
	    if(myp!=null){
		Object[] possibleValues = {"Move Pic.","Add","Move Point","Remove"};
		
		Object cselectedvalue= possibleValues[mouseState];
		
		Object selectedValue = JOptionPane.showInternalInputDialog(this,
									   "Choose one", "Mouse Action Selection",
									   JOptionPane.INFORMATION_MESSAGE, null,
									   possibleValues, cselectedvalue);
		if(selectedValue!=null){
		    if(selectedValue.equals(possibleValues[0])){
			mouseState=0;
		    }else if(selectedValue.equals(possibleValues[1])){
			mouseState=1;
		    }else if(selectedValue.equals(possibleValues[2])){
			mouseState=2;
		    }else if(selectedValue.equals(possibleValues[3])){
			mouseState=3;
		    }
		    setMode(mouseState);
		    //mypcontrol.setMode(mouseState);
		}
	    }
	    
	}else if(e.getModifiers() == e.BUTTON1_MASK){
	    if(myp!=null){
		picked=null;
		Point cp = e.getPoint();
		double dx = ((double)(cp.x-tvecx))/scale;
		double dy = ((double)(cp.y-tvecy))/scale;
		picked = myp.pick(dx,dy,tid);//System.out.println("Picked 2!");
	    }
	    if(picked!=null){
		
		if(mouseState!=3){
		    //System.out.println("Picked 1!");
		    preScroll.setCursor(hndCursor);
		    pp.setLocation(e.getPoint());
		}else{
		    Point cp = e.getPoint();
		    double dx = ((double)(cp.x-tvecx))/scale;
		    double dy = ((double)(cp.y-tvecy))/scale;
		    myp.remove(dx,dy,(scale*classR*cRadius),tid);
		    //System.out.println(+myp.pclass.size());
		    if(myp.pclass.size()==0){
			selectedClass = myp.addClass(ccolor,cfillcolor,0,1);
			
			
		    }else{
			selectedClass = myp.pclass.elementAt(0);
			
			
		    }
		    //System.out.println(+myp.pclass.size());
		    if(selectedClass!=null)
			selectedClass.setCnum(tid);
		    
		}
		
	    }else{
		if(mouseState==1)
		    if(myp!=null&&selectedClass!=null){
			
			Point cp = e.getPoint();
			int cx1 = sourcecx-sourcew/2;
			int cy1 = sourcecy-sourceh/2;
			int cx2 = sourcecx+sourcew/2;
			int cy2 = sourcecy+sourceh/2;
						
			double dx = ((double)(cp.x-tvecx))/scale;
			double dy = ((double)(cp.y-tvecy))/scale;
			double cx1s = ((double)(cx1))*scale;
			double cy1s = ((double)(cy1))*scale;
			double cx2s = ((double)(cx2))*scale;
			double cy2s = ((double)(cy2))*scale;
			
			
			if(cx1s<=cp.x-tvecx&&cp.x-tvecx<=cx2s&&cy1s<=cp.y-tvecy&&cp.y-tvecy<=cy2s){
			
			addParticle(dx,dy,((double)(tid)),cRadius,classR,tid);
			}
		    }
		
	    }
	    /* 
		   0: move/zoom image
		   1: add particle
		   2: move/pick particle
		   3: remove particle
		   
		*/
	    /*
	    if(mouseState==1){
		
		if(myp!=null&&selectedClass!=null){
		    Point cp = e.getPoint();
		    double dx = ((double)(cp.x))/scale;
		    double dy = ((double)(cp.y))/scale;
		    
		    
		    addParticle(dx,dy,((double)(tid)),cRadius,classR,tid);
		    
		}
	    }else if(mouseState==2){
		if(myp!=null){
		    Point cp = e.getPoint();
		    double dx = ((double)(cp.x))/scale;
		    double dy = ((double)(cp.y))/scale;
		    picked = myp.pick(dx,dy,tid);
		}
		if(picked==null){
		    preScroll.setCursor(hndCursor);
		    pp.setLocation(e.getPoint());
		    
		}
	    }else if(mouseState==3){
		if(myp!=null){
		    Point cp = e.getPoint();
		    double dx = ((double)(cp.x))/scale;
		    double dy = ((double)(cp.y))/scale;
		    myp.remove(dx,dy,(scale*classR*cRadius),tid);
		    
		    if(myp.pclass.size()==0){
			selectedClass = myp.addClass(ccolor,cfillcolor,0,0);
			//mypcontrol.toptree.add(mypcontrol.selectedClass.tnode);
			//mypcontrol.tree.setSelectionPath(new TreePath(selectedClass.tnode.getPath()));
			
			//mypcontrol.selectedClass=selectedClass;
			
		    }else{
			selectedClass = myp.pclass.elementAt(0);
			
			//mypcontrol.selectedClass=selectedClass;
		    }
		    selectedClass.setCnum(tid);
		    
		    //mypcontrol.tree.updateUI(); 
		    //mypcontrol.treeView.updateUI();
		    //mypcontrol.setNumbers();
		    
		}
		
	    }else if(mouseState==0){
		
		preScroll.setCursor(hndCursor);
		pp.setLocation(e.getPoint());
	    }
	    */
	}
    }
    public void addParticle(double dx,double dy,double dz,double dr,double dcr,int dtid){
	selectedClass.add(dx,dy,dz,dr,dcr,dtid);
	selectedClass.setCnum(tid);
	//mypcontrol.setNumbers();
	//mypcontrol.tree.updateUI();
	//mypcontrol.treeView.updateUI();
    }
    
    public void mouseExited(MouseEvent e) {mousein=false;}
    public void mouseEntered(MouseEvent e){mousein=true;}
    public void mouseReleased(MouseEvent e) {mousein=true;
	preScroll.setCursor(defCursor);
	makeImage();
	repaint();
    }
    public void initRadius(){
	cRadius = 5.0;
	makeImage();
	repaint();	
    
    }
    public void mouseClicked(MouseEvent e){mousein=true;
	if (e.getClickCount() >= 2){//double click for scale reset
	    if(mouseState==1||mouseState==3){
		initRadius();
	    }else{
		scale=1.0d;
		
		makeImage();
		repaint();
		setSize();
	    }
	}

    }
    
    public void mouseWheelMoved(MouseWheelEvent e) { 
	/*
	   0: Z(Time)
	   1: Class
	   2: Radius
	   3: Zoom
	*/
	  
	int val = e.getWheelRotation();
	
	//mycontrol.setMouseWheelState(mouseWheelState);
	/*
	if(mouseState==1||mouseState==3){
	    if(keyaction.mouseWheelState==0){
		if(myIWpcontrol!=null)myIWpcontrol.IncMW(val);
	    }else if(keyaction.mouseWheelState==1){
		if(mypcontrol!=null)mypcontrol.changeSelectedClass(val);
	    }else if(keyaction.mouseWheelState==2){
		cRadius += 0.5*((double)(val));if(cRadius<=0.0)cRadius=0.0;
		mypcontrol.setpRadius();
		repaint();
	    }
	}else{
	    
	    changeScale(e.getWheelRotation(),e.getPoint());//updatePreferredSize(e.getWheelRotation(), e.getPoint());
	    repaint();
	}
	*/
	//if(!(mouseState==1||mouseState==3)){
	    changeScale(e.getWheelRotation(),e.getPoint());//updatePreferredSize(e.getWheelRotation(), e.getPoint());
	    repaint();
	    //}
	
    }
    

}
