import java.util.Vector;
import java.awt.*;
import java.util.Iterator;
import javax.swing.tree.DefaultMutableTreeNode;

class Particles{
    
    

   
    Vector <ParticleClass> pclass=null;
    
    
    
    
    public Particles(){
	
	
	
	pclass = new Vector<ParticleClass>();
    }
    public int getPnum(int tid){
	int sum=0;
	int i;int last = pclass.size();
	for(i=0;i<last;i++){ParticleClass mpc = pclass.elementAt(i);
	    sum+=mpc.particles[tid].size();
	}
	return sum;
    }

    public int getPnum(){
	int sum=0;
	int i;int last = pclass.size();
	for(i=0;i<last;i++){
	    ParticleClass mpc = pclass.elementAt(i);
	    int j;
	    for(j=0;j<mpc.sz;j++){
		sum+=mpc.particles[j].size();
	    }
	}
	return sum;
    }
    
    
    public int getCnum(int tid){
	int sum=0;
	int i;int last = pclass.size();
	for(i=0;i<last;i++){
	    ParticleClass mpc = pclass.elementAt(i);
	    mpc.setCnum(tid);
	    if(mpc.particles[tid].size()>0){
		sum++;
	    }
	}
	return sum;
    }
    public Particle pick(double dx,double dy,int tid){
	boolean first=true;
	Particle picked = null;
	double mindist=0.0;
	int i;int last = pclass.size();
	for(i=0;i<last;i++){
	    ParticleClass mpc = pclass.elementAt(i);
	    int j;int lastj = mpc.particles[tid].size();
	    
	    for(j=0;j<lastj;j++){
		Particle cp = mpc.particles[tid].elementAt(j);
		if(cp.isIn(dx,dy)){
		double ddx = cp.x-dx;
		double ddy = cp.y-dy;
		double dist = ddx*ddx+ddy*ddy;
		if(first){
		    picked = cp;
		    mindist=dist;
		    first=false;
		}else{
		    if(mindist>dist){
			picked = cp;
			mindist=dist;
		    
		    }
		}
	    }
	    }
	}
	return picked;
    }

    
    public void setPolygon(Polygon mypoly,double scale){
		int i;int last = pclass.size();
	for(i=0;i<last;i++){
	    ParticleClass mpc = pclass.elementAt(i);
	    int j;int lastj = mpc.particles[0].size();
	    
	    for(j=0;j<lastj;j++){
		Particle cp = mpc.particles[0].elementAt(j);
		
		int dx = ((int)(cp.x*scale));if(cp.x-dx>=0.5)dx++;
		int dy = ((int)(cp.y*scale));if(cp.y-dy>=0.5)dy++;
		mypoly.addPoint(dx,dy);
	    }
	}
	
    
    }
    public void draw(Graphics2D g2d,int tid){

	
	int i;int last = pclass.size();
	for(i=0;i<last;i++){
	    ParticleClass mpc = pclass.elementAt(i);
	    int j;int lastj = mpc.particles[tid].size();
	    
	    for(j=0;j<lastj;j++){
		Particle cp = mpc.particles[tid].elementAt(j);
		
		int dx = ((int)(cp.x));if(cp.x-dx>=0.5)dx++;
		int dy = ((int)(cp.y));if(cp.y-dy>=0.5)dy++;
		double ddr = ((double)(cp.r*mpc.baseR));
		int dr = ((int)(ddr));if(ddr-dr>=0.5)dr++;
		int dr2=2*dr;
	    
		g2d.setColor(mpc.pcolor);
		g2d.drawOval(dx-dr,dy-dr,dr2,dr2);
		g2d.setColor(mpc.pfillcolor);
		g2d.fillOval(dx-dr,dy-dr,dr2,dr2);
	    
		
	    }
	     for(j=0;j<lastj-1;j++){
		 Particle cp = mpc.particles[tid].elementAt(j);
		
		int dx = ((int)(cp.x));if(cp.x-dx>=0.5)dx++;
		int dy = ((int)(cp.y));if(cp.y-dy>=0.5)dy++;
		cp = mpc.particles[tid].elementAt(j+1);
		
		int dx2 = ((int)(cp.x));if(cp.x-dx>=0.5)dx++;
		int dy2 = ((int)(cp.y));if(cp.y-dy>=0.5)dy++;
		
		g2d.drawLine(dx,dy,dx2,dy2);
	     }
	     if(lastj>=3){
		 Particle cp = mpc.particles[tid].elementAt(lastj-1);
		
		int dx = ((int)(cp.x));if(cp.x-dx>=0.5)dx++;
		int dy = ((int)(cp.y));if(cp.y-dy>=0.5)dy++;
		cp = mpc.particles[tid].elementAt(0);
		
		int dx2 = ((int)(cp.x));if(cp.x-dx>=0.5)dx++;
		int dy2 = ((int)(cp.y));if(cp.y-dy>=0.5)dy++;
		
		g2d.drawLine(dx,dy,dx2,dy2);
		
	     }
	}
    
    }
    
    
    public void deconstractor(){
	int i;int last = pclass.size();
	for(i=0;i<last;i++){
	    ParticleClass mpc= pclass.elementAt(i);
		mpc.deconstractor();
	}
	pclass.removeAllElements();
	
	
	pclass = new Vector<ParticleClass>();
    }
    /*
    public void add(double dx,double dy,double dz,double dr,int cID,Color ccolor,Color cfillcolor,int tID){
	int pcsize = pclass.size();
	if(pcsize==0){
	    pclass.add(new ParticleClass(ccolor,cfillcolor));
	    ParticleClass mpc =  pclass.elementAt(0);
	    mpc.add(dx,dy,dz,dr,tID);
	   
	}else{
	    pclass.elementAt(cID).add(dx,dy,dz,dr,tID);
	}
    }
*/
    
    public ParticleClass addClass(Color ccolor,Color cfillcolor,int ID,int sz){
	ParticleClass pcnode = new ParticleClass(ccolor,cfillcolor,ID,sz);
	pclass.add(pcnode);
	return pcnode;
    }
    
    public void removeClass(ParticleClass removeid){
	
	
	    
	removeid.deconstractor();
	pclass.remove(removeid);
	
    
    }
    
    public void remove(double dx,double dy,double dr,int tid){
	int i;
	for(i=0;i<pclass.size();i++){
	    ParticleClass mpc = pclass.elementAt(i);
	    int j;
	    
	    for(j=0;j<mpc.particles[tid].size();j++){
		if(j<0)j=0;
		Particle cp = mpc.particles[tid].elementAt(j);
		if(cp.intersect(dx,dy,dr)){
		    mpc.particles[tid].removeElement(cp);//elementAt(j);
		    j--;
		}
	    }
	    if(mpc.getPnum()<=0){
		
		pclass.remove(mpc);
	    }
	    
	}
    
    }
    /*
    public void remove(Particle rp){
	int i;int last = pclass.size();
	boolean checkremove=false;
	for(i=0;i<pclass.size();i++){
	    ParticleClass mpc = pclass.elementAt(i);
	    int j;int lastj = mpc.particles.size();
	    
	    for(j=0;j<lastj;j++){
		Particle cp = mpc.particles.elementAt(j);
		if(cp==rp){
		    mpc.particles.remove(rp);checkremove=true;
		    break;
		}
	    }
	    if(mpc.particles.size()<=0){
		pclass.remove(mpc);
	    }
	    if(checkremove)break;
	    
	}
    }
    */
    /*
    public void setCColor(Color dpcolor,ParticleClass selectedClass){
	if(pclass.size()>0)selectedClass
	    pclass.elementAt(cID).pcolor = dpcolor;
    }
    public void setCFillColor(Color dpcolor,int cID){
	if(pclass.size()>0)
	    pclass.elementAt(cID).pfillcolor = dpcolor;
    }
    */

}