import java.awt.*;
import java.awt.Dimension;
import java.awt.Rectangle;
import java.awt.image.Raster;
import java.awt.image.RenderedImage;
import java.awt.image.renderable.ParameterBlock;
import java.beans.PropertyChangeListener;
import java.io.*;
import java.util.*;

import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import javax.swing.WindowConstants;
import java.awt.image.BufferedImage;
import javax.swing.JInternalFrame;
import java.awt.event.*;
import javax.swing.*;
public class ImageWindow extends JInternalFrame implements ActionListener, AdjustmentListener{

    DisplayJAI prePanel;
    
    
    static int openFrameCount = 0;
    static final int xOffset = 30, yOffset = 30;
    int viewid=0;
    
    BufferedImage preEventImage=null;
    int sx,sy;
    JScrollBar transparent;
    JScrollBar radius;
    JButton ColorChoose;
  

    public ImageWindow(String filename,String title){
	super(title, 
              true, //resizable
              false, //closable
              true, //maximizable
              true);
	

	
        preEventImage = getBufferedImage(filename);
	
	setLayout(new BorderLayout());
	sx = preEventImage.getWidth();
	sy = preEventImage.getHeight();
	
	
	
	prePanel = new DisplayJAI(preEventImage);

	
	
	java.awt.Container pane = this.getContentPane();
	
	
	
	//prePanel.setSize(sx,sy);
	JScrollPane preScroll = new JScrollPane(prePanel);
	
	
	if(sx>1024&&sy>1024){
	    preScroll.setPreferredSize(new Dimension(515,515));
	 }else{
	     preScroll.setPreferredSize(new Dimension(sx+3,sy+3));
	 }
	prePanel.setJScrollPane(preScroll);
	pane.add("Center",preScroll);
	
	transparent = new JScrollBar(JScrollBar.HORIZONTAL,128,4,0,259);
	transparent.addAdjustmentListener(this);
	
	ColorChoose = new JButton("Select");
	ColorChoose.addActionListener(this);
	
	ColorChoose.setOpaque(true);
	ColorChoose.setBackground(prePanel.cfillcolor);
	
	JPanel pc = new JPanel();
	pc.setLayout(new BorderLayout());
	
	pc.add("Center",transparent);
	
	pc.add("East",ColorChoose);
	pane.add("South",pc);

	radius = new JScrollBar(JScrollBar.VERTICAL,10,4,1,259);
	radius.addAdjustmentListener(this);
	pane.add("East",radius);
	prePanel.radiusSB = radius;
	
	this.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
	
	this.pack(); 
	
	this.setVisible(true);
	setLocation(xOffset*openFrameCount, yOffset*openFrameCount);
    }

    public void adjustmentValueChanged(AdjustmentEvent adjustmentEvent) {
	Object source = adjustmentEvent.getSource();
	if(source==transparent){
	    int val= adjustmentEvent.getValue();
	    
	   
	    
	    //System.out.println(+val);
	    prePanel.setTransparent(((float)(val/255.0)));
	    
	    
	}else if(source==radius){
	    prePanel.setRadius(adjustmentEvent.getValue());
	    
	}
    }
    
    public boolean isReady(){
	if(prePanel.target!=null)return true;
	return false;
    
    }
    public void setSaveMasks(String filename){
	prePanel.setSaveMasks(filename);

    }
    
    
    private BufferedImage getBufferedImage(String filename){
	BufferedImage myimg=null;
	try{
	    
	    FileInputStream  input = 
		new FileInputStream (filename);
	    LineNumberReader lnr = 
		new LineNumberReader(new BufferedReader(new InputStreamReader(input)));
	    StringTokenizer st;
	    st = new StringTokenizer(lnr.readLine());
	    st.nextToken();
	    if(!st.hasMoreTokens())
		st = new StringTokenizer(lnr.readLine());
	    sx = (Integer.valueOf(st.nextToken())).intValue(); 
	    sy = (Integer.valueOf(st.nextToken())).intValue(); 
	    if(!st.hasMoreTokens())
		st = new StringTokenizer(lnr.readLine());
	    int gray =  (Integer.valueOf(st.nextToken())).intValue(); 
	    myimg = new BufferedImage(sx,sy,BufferedImage.TYPE_3BYTE_BGR);
	    
	    int i,j;
	    for(i=0;i<sy;i++)
		for(j=0;j<sx;j++){
		    int dummyR,dummyG,dummyB;
		    if(!st.hasMoreTokens())
			st = new StringTokenizer(lnr.readLine());
		    dummyR=  (Integer.valueOf(st.nextToken())).intValue();
		    dummyG=  (Integer.valueOf(st.nextToken())).intValue();
		    dummyB=  (Integer.valueOf(st.nextToken())).intValue();
		    
		    int val = ((255 << 24)|(dummyR << 16)|(dummyG << 8)|dummyB);
		    myimg.setRGB(j,i,val);
		    
		}
	    lnr.close();
	    input.close();
	}catch (IOException e){
	    System.out.println("IOException");
	}
	
	return myimg;
    }
    
    public void paint(){
	prePanel.repaint();
    }
    public void closeWindow(){
	
	System.gc();
	this.dispose();
    }
    
    
   
     public void actionPerformed(ActionEvent e) {
	 Color dcolor= JColorChooser.showDialog(this,"Choose new color for painting.",prePanel.cfillcolor);
	 prePanel.setPaintingColor(dcolor);
	 ColorChoose.setBackground(prePanel.cfillcolor);
     }
    
}
